/***********************************************
 *
 * Angelscript Dumper v2.1 by learn_more
 * File: out\a164\script\cam_dump.as
 * Generated: 14-Jan-2012 18:08:19
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x38a5b0 (0x78a5b0)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xb7790 (0x4b7790)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xb77c0 (0x4b77c0)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x38aa30 (0x78aa30)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x38b170 (0x78b170)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x38af00 (0x78af00)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x38adf0 (0x78adf0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x38b1d0 (0x78b1d0)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x38acc0 (0x78acc0)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x38a9e0 (0x78a9e0)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x38b1a0 (0x78b1a0)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x38aa60 (0x78aa60)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x38ab90 (0x78ab90)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x38a600 (0x78a600)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x38a100 (0x78a100)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x22c810 (0x62c810)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x22b770 (0x62b770)
	void CallFunction(uint32, string);		// 'Overgrowth.exe' + 0x22b7d0 (0x62b7d0)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x22c690 (0x62c690)
	void Update();		// 'Overgrowth.exe' + 0x2300d0 (0x6300d0)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x284840 (0x684840)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2847f0 (0x6847f0)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x34dbf0 (0x74dbf0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x34da50 (0x74da50)
	quaternion GetRotation();		// 'Overgrowth.exe' + 0x34da10 (0x74da10)
	float GetLens();		// 'Overgrowth.exe' + 0x34da30 (0x74da30)
	void Update();		// 'Overgrowth.exe' + 0x34cbd0 (0x74cbd0)
	bool valid();		// 'Overgrowth.exe' + 0x34bf90 (0x74bf90)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;
SphereCollision sphere_col;
GUI gui;
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x3f86a0 (0x7f86a0)
CameraObject co;
CameraAnimationReader camera_animation_reader;
